      SUBROUTINE AFJ0P(BR,BI,CR,CI,N,IERR)
      DIMENSION BR(N),BI(N),CR(N),CI(N)
      INTEGER N,IERR,I
      DOUBLE PRECISION BR,BI,CR,CI,W,UR,UI,BRI,BII,CRI,CII,
     1B,SB,C,SC,S,SYS056,SYS052,DSQRT,DABS,DSIGN
      COMPLEX*16 CDABS,CB,CC,DCMPLX
      DATA  SYS052/2.22044592D-16/,SYS056/
     15.56268464627D-308/
      W=8.D0*SYS052
      IERR=0
      CR(1)=1.D0
      CI(1)=0.D0
      UR=1.D0
      UI=0.D0
      IF(N.EQ.1) GO TO 7
      DO 4 I=2,N
      BRI=BR(I)
      BII=BI(I)
      CRI=CR(I)
      CII=CI(I)
      CB=DCMPLX(BRI,BII)
      B=CDABS(CB)
      SB=DSQRT(B)
      CC=DCMPLX(CRI,CII)
      C=CDABS(CC)
      SC=DSQRT(C)
      S=SB*SC
      BR(I)=S
      IF(B.EQ.0.D0.AND.C.EQ.0.D0) GO TO 2
      IF(S.EQ.0.D0) GO TO 6
      SB=BRI/B
      SC=CRI/C
      IF(DABS(SB-SC).GT.(DABS(SB)+DABS(SC))*W) GO TO 5
      SB=0.D0
      SC=0.D0
      IF(BII.NE.0.D0) SB=DSIGN(1.D0,BII)
      IF(CII.NE.0.D0) SC=-DSIGN(1.D0,CII)
      IF(SB.NE.SC) GO TO 5
      IF(IERR.EQ.68) GO TO 4
      S=1.D0/S
      CRI=CRI*S
      CII=CII*S
      C=DMAX1(DABS(CRI),DABS(CII))
      B=DMAX1(DABS(UR),DABS(UI))
      IF(C*SYS056*B.LT.0.5D0) GO TO 1
      IERR=68
      GO TO 4
    1 BRI=UR*CRI-UI*CII
      BII=UI*CRI+UR*CII
      GO TO 3
    2 BRI=1.D0
      BII=0.D0
    3 CR(I)=BRI
      CI(I)=BII
      UR=BRI
      UI=BII
      IF(UR.EQ.0.D0.AND.UI.EQ.0.D0) IERR=68
    4 CONTINUE
      GO TO 7
    5 IERR=66
      GO TO 7
    6 IERR=67
    7 IF(IERR.NE.0) CALL UTAF13(IERR,4)
      RETURN
      END
